############
##
## This is to prepare IC for NINO pacemaker simulation (see gitlab issue experiments#XXXX
##
## Method: use ICs from previous EC-Earth3-CC historical simulations
##            - untar IC from year "sdate", year "sdate - 5" and year "sdate + 4"
##            - ...
###############
#!/bin/sh
#set -vx
# 

# These ones in dt machine
copystep=False
namestep=False
# This one in Nord3v2
datestep=True

sdate=2010
exp=nino1516
exp_time=present
atm_res=T255L91
oce_res=ORCA1L75
coup_oce_res=T255-ORCA1
land_res=T255
ice_res=ORCA1_LIM3
expid_list=(a3bh a3bh a3o0 a3nm a3o2 a3o4 a3o1 a3o7 a3o3 a45i)
#expid_list=(a3bh a3bh a3o0)
fc_list=(0 1 0 0 0 0 0 0 0 0)
period_list=(4 4 0 0 0 0 0 0 0 0)
#basedir=/gpfs/archive/bsc32/esarchive/scratch/ptrascas/ninopacemaker/exp/${exp}_${exp_time}                                                                                                                     
basedir=/esarchive/scratch/ptrascas/ninopacemaker/exp/${exp}_${exp_time}
basetardir=/gpfs/archive/bsc32/esarchive/exp/ecearth
pwdir=$(pwd)



######## Nothing to change after this line !!!
let sdate1="${sdate} - 1"
let sdatem="${sdate} - 5"
let sdatep="${sdate} + 4"

if [ ${copystep} == "True" ];then
    m=0
    for e in ${!expid_list[*]}; do
	expid=${expid_list[$e]}
	fc=${fc_list[$e]}
	period=${period_list[$e]}
	for y in ${sdatem} ${sdate1} ${sdatep}; do
	    # Warning: missing IC from lpjg for historical a3bh_fc1 at 20041231
	    if [ ${fc} == "1" ] && [ ${y} == "2004" ]; then
		let y="${y} + 1"
	    fi
            if [ ${m} -lt 10 ]; then
		outdir=${basedir}/fc0${m}
		echo fc0${m}
            else
		outdir=${basedir}/fc${m}
		echo fc${m}
            fi
            mkdir -p ${outdir}
            tardir=${basetardir}/${expid}/original_files/18500101/fc${fc}/ic
            tarfile=${tardir}/IC_${expid}_18500101_fc${fc}_*_${period}_${y}0101-${y}1231.tar
	    dttar xvf ${tarfile} -C ${outdir}/.
	    let m="${m} + 1"
	done
    done
fi
cd ${pwdir}

mb=0
for e in ${!expid_list[*]}; do
    for y in ${sdatem} ${sdate1} ${sdatep}; do
	let mb="${mb} + 1"
    done
done
let mb="${mb} - 1"

if [ ${namestep} == "True" ];then
    for i in $(seq -w 00 ${mb}); do
	echo fc:fc${i}

	### atmos ICs
	cd ${pwdir}
        comp=atmos
        res=$atm_res
	dttar xvfz ${basedir}/fc${i}/${comp}/${res}/*/* -C ${basedir}/fc${i}/${comp}/${res}/*/.
     
	### lpjg ICs
	cd ${pwdir}
	comp=lpjg
	res=$land_res
	dttar xvfz ${basedir}/fc${i}/${comp}/${res}/*/* -C ${basedir}/fc${i}/${comp}/${res}/*/.
		
	# ocean ICs
	cd ${pwdir}
	comp=ocean
	res=$oce_res
	outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
	dtmv ${basedir}/fc${i}/${comp}/${res}/*/* ${outdir}/${exp}_${exp_time}_fc${i}_${sdate1}1231_restart.nc.gz
      
        # oceantrc ICs
        cd ${pwdir}
        comp=oceantrc
        res=$oce_res
	outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
        dtmv ${basedir}/fc${i}/${comp}/${res}/*/* ${outdir}/${exp}_${exp_time}_fc${i}_${sdate1}1231_restart_trc.nc.gz

	# ice ICs
        cd ${pwdir}
	comp=ice
	res=$ice_res
	outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
	dtmv ${basedir}/fc${i}/${comp}/${res}/*/* ${outdir}/${exp}_${exp_time}_fc${i}_${sdate1}1231_restart_ice.nc.gz
	
	# coupler ICs
	cd ${pwdir}
	comp=coupler
	res=$coup_oce_res
        outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
	dtmv ${basedir}/fc${i}/${comp}/${res}/*/*_rstas.nc.gz ${outdir}/${exp}_${exp_time}_fc${i}_${sdate}010100_rstas.nc.gz
        dtmv ${basedir}/fc${i}/${comp}/${res}/*/*_rstos.nc.gz ${outdir}/${exp}_${exp_time}_fc${i}_${sdate}010100_rstos.nc.gz
	
	cd ${pwdir}
        comp=coupler
        res=$land_res
	outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
        dtmv ${basedir}/fc${i}/${comp}/${res}/*/*_lpjgv.nc.gz ${outdir}/${exp}_${exp_time}_fc${i}_${sdate}010100_lpjgv.nc.gz
        dtmv ${basedir}/fc${i}/${comp}/${res}/*/*_vegin.nc.gz ${outdir}/${exp}_${exp_time}_fc${i}_${sdate}010100_vegin.nc.gz
	
    done
fi



#basedir_nord3=$(echo ${basedir} | sed 's/"/gpfs/archive/bsc32/"/"/"/g')
if [ ${datestep} == "True" ];then
    module load grib_api

    for i in $(seq -w 00 ${mb}); do
	echo fc:fc${i}

	### atmos
        cd ${pwdir}
        comp=atmos
        res=$atm_res
        indir=${basedir}/fc${i}/${comp}/${res}/*
        outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
	grib_set -s dataDate=${sdate}0101 ${indir}/ICMGG*INIT ${outdir}/ICMGG${exp}_${exp_time}INIT
        grib_set -s dataDate=${sdate}0101 ${indir}/ICMGG*INIUA ${outdir}/ICMGG${exp}_${exp_time}INIUA
        grib_set -s dataDate=${sdate}0101 ${indir}/ICMSH*INIT ${outdir}/ICMSH${exp}_${exp_time}INIT
        cd ${outdir}
        tar cvfz ${exp}_${exp_time}_fc${i}_${sdate}0101.tar.gz ICM*
	rm ICM*
	
	### lpjg
        cd ${pwdir}
        comp=lpjg
        res=$land_res
	indir=${basedir}/fc${i}/${comp}/${res}/*
        outdir=${basedir}/IC/${comp}/${res}/${exp}_${exp_time}
        mkdir -p ${outdir}
        cd ${outdir}
       # mv ${indir}/lpjg_state_* lpjg_state_${sdate}
	cp -r ${indir}/lpjg_state_* lpjg_state_${sdate} 	
	tar cvfz ${exp}_${exp_time}_fc${i}_${sdate}010100_lpjg.tgz lpjg_state_${sdate}
	rm -rf lpjg_state_${sdate}

    done
fi
